# Generated by Django 5.0 on 2024-07-16 19:15

from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Task",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("queue", models.CharField(max_length=64)),
                ("task", models.CharField(max_length=256)),
                ("args", models.JSONField()),
                ("kwargs", models.JSONField()),
                ("execute_at", models.DateTimeField(auto_now_add=True)),
                ("expires", models.DateTimeField(blank=True, null=True)),
                ("retries", models.PositiveIntegerField(default=0)),
                ("traceback", models.TextField(blank=True, null=True)),
                ("started_at", models.DateTimeField(blank=True, null=True)),
                ("started", models.BooleanField(default=False)),
                ("failed", models.BooleanField(default=False)),
            ],
            options={
                "indexes": [
                    models.Index(
                        condition=models.Q(("failed", False), ("started", False)),
                        fields=["execute_at", "queue"],
                        name="dttq_task_execute_at_queue_idx",
                    )
                ],
            },
        ),
        migrations.CreateModel(
            name="DirtyTask",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("dttq.task",),
        ),
        migrations.CreateModel(
            name="FailedTask",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("dttq.task",),
        ),
        migrations.CreateModel(
            name="StartedTask",
            fields=[],
            options={
                "proxy": True,
                "indexes": [],
                "constraints": [],
            },
            bases=("dttq.task",),
        ),
    ]
